<?xml version="1.0"?>

<queryset>
   <rdbms><type>postgresql</type><version>7.1</version></rdbms>

<fullquery name="message-display">
      <querytext>      
        select sender_user_id, party_name as sender, date_trunc('second', sent_timestamptz) as sent_date, 
                 subject, body, priority_p
        from im_message m, party_names p
        where m.sender_user_id = p.party_id
        and m.message_id = :message_id
      </querytext>
</fullquery>

<fullquery name="to_addressees">
      <querytext>
        select party_name as addressee_name, addressee_id as party_id
        from im_addressees a, party_names p
        where a.addressee_id = p.party_id
        and address_mode_id = 1
        and exists (
                select * from im_message m
                where m.message_id = :message_id
                and a.message_id = m.message_id)
      </querytext>
</fullquery>

<fullquery name="cc_addressees">
      <querytext>
        select party_name as addressee_name, addressee_id as party_id
        from im_addressees a, party_names p
        where a.addressee_id = p.party_id
        and address_mode_id = 2
        and exists (
                select * from im_message m
                where m.message_id = :message_id
                and a.message_id = m.message_id)
      </querytext>
</fullquery>

<fullquery name="bcc_addressees">
      <querytext>
        select party_name as addressee_name, addressee_id as party_id
        from im_addressees a, party_names p
        where a.addressee_id = p.party_id
        and address_mode_id = 3
        and exists (
                select * from im_message m
                where m.message_id = :message_id
                and a.message_id = m.message_id)
      </querytext>
</fullquery>

<fullquery name="user_bcc_p">
      <querytext>
        select im_message__user_bcc_p(:message_id, :user_id) as user_bcc_p
      </querytext>
</fullquery>

<fullquery name="bcc_user_name">
      <querytext>
        select party_name as bcc_user_name
        from party_names
        where party_id = :user_id
      </querytext>
</fullquery>

<fullquery name="message_send">
      <querytext>
        select im_message__send (:message_id) as message_send_successful_p
      </querytext>
</fullquery>

<fullquery name="message_sent_p">
      <querytext>
        select im_message__sent_p(:message_id) as message_sent_p
      </querytext>
</fullquery>

<fullquery name="mark_read_if_appropriate">
      <querytext>
        select im_mark_read_p (:message_id, :user_id)
      </querytext>
</fullquery>

<fullquery name="message_author_p">
      <querytext>
        select im_message__author_p(:message_id, :user_id) as message_author_p
      </querytext>
</fullquery>

<fullquery name="message_addressee_p">
      <querytext>
        select im_message__addressee_p(:message_id, :user_id) as message_addressee_p
      </querytext>
</fullquery>

</queryset>
